#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Aqua
#property indicator_width1 1
#property indicator_color2 Red
#property indicator_width2 1

#include <WebGet.mqh>
//Daily Average Levels
#define AvBUY150 "AvBUY150"
#define AvBUY125 "AvBUY125"
#define AvBUY100 "AvBUY100"
#define AvBUY75 "AvBUY75"
#define AvSELL75 "AvSELL75"
#define AvSELL100 "AvSELL100"
#define AvSELL125 "AvSELL125"
#define AvSELL150 "AvSELL150"


//---- Heiken Ashi colors
#property indicator_color3 Red
#property indicator_color4 Chartreuse
#property indicator_color5 Red
#property indicator_color6 Chartreuse

//---- input parameters

extern string   xx                        = "==Mandarine==";
extern int      T3Period                  = 5;
extern int      T3Price                   = PRICE_CLOSE;
extern double   T3Hot                     = 1.0;
extern bool     T3Original                = true;
extern int      Fast                      = 5;
extern int      Slow                      = 20;
extern int      SigShift                  = 1;

extern string   x                         = "==Mandarine Alerts==";
extern bool     UseSound                  = 1;
extern bool     CommentOnChart            = 1;
extern string   NameFileSound             = "train.wav";

extern string   MoneyManagementSetting    = "==MoneyManagementSettings==";
extern bool     UseAutomaticMM            = true;
extern double   Risk                      = 2.50;
extern double   BaseLot                   = 0.05;
extern double   Risk_to_Reward_ratio      = 3.0;
extern double   Range.trailingStop        = 0.25;
extern double   Range.stopLoss            = 0.25;

extern string   HeikenAshiSetting         = "==HeikenAshiSettings==";
extern string   _nlma                     = "==NlmaHa Settings===";
extern bool     ShowHeikenAshi            = true;
extern int      NLMA_TF                   = 0;
extern int      NLMA_Length               = 9;   //Period of NonLagMA
extern int      NLMA_Displace             = 0;    //DispLace or Shift 
extern double   NLMA_PctFilter            = 0;    //Dynamic filter in decimal

extern string   DailyRangeSetting         = "==DailyRangeSettings==";
extern bool     Show_DailyAverageGRAPHICS = false;
extern bool     Daily_AverageGRAPHICS     = false;
extern color    DAILY_Av_UP_Color_150     = LightGray;           
extern color    DAILY_Av_DN_Color_150     = LightGray;           
extern int      ShortRange                = 5;
extern int      InterRange                = 10;
extern int      LongRange                 = 20;   


extern string   FiboPivotSetting          = "==FiboPivotSettings==";
extern bool     ShowLines                 = True;
extern color    Resistance_3              = Red;
extern color    Resistance_2              = Red;
extern color    Resistance_1              = Red;
extern color    Pivot                     = Gold;
extern color    Support_1                 = DodgerBlue;
extern color    Support_2                 = DodgerBlue;
extern color    Support_3                 = DodgerBlue;

extern string   _news                     = "==News Filter==";
extern string   CalendarName              = "ForexTSD";
extern int      CalendarID                = 4;     // Calendar's ID on calendar.forex-tsd.com  
extern bool     UseStartDate              = false; 
extern datetime StartDate                 = D'2007.04.10';      
extern bool     AlertMode                 = false;
extern int      AlertTimeGap              = 1;     // Time Gap between News Time and Alert Time in min 
extern bool     DisplayLine               = false; // Display Line Option (Visualization mode) 
extern bool     DisplayText               = false; // Display Text Option (Visualization mode)

extern string   cFilter                   = "==Currency Filter==";
extern bool     USD                       = true;
extern bool     EUR                       = true;
extern bool     GBP                       = true;
extern bool     JPY                       = true;
extern bool     AUD                       = true;
extern bool     CAD                       = true;
extern bool     CHF                       = true;
extern bool     NZD                       = true;

extern string   rFilter                   = "==Rating Filter==";
extern int      MaxRating                 = 3;
extern int      MinRating                 = 3;  


//---- buffers
double   buy[];
double   sell[];
//---- Heiken Ashi Buffers
double   ExtMapBuffer5[];
double   ExtMapBuffer6[];
double   ExtMapBuffer7[];
double   ExtMapBuffer8[];

int      ExtCountedBars=0;
int      last;
int      nDigits;
int      NewsNum;
int      TimeZone;

double   pointvalue;
double   alertTag;
double   avg.rng, rng, sum.rng;

string   sDate[1000];          // Date
string   sTime[1000];          // Time
string   sCurrency[1000];      // Currency
string   sDescription[1000];   // Description
string   sRating[1000];        // Rating
string   sActual[1000];        // Actual value
string   sForecast[1000];      // Forecast value
string   sPrevious[1000];      // Previous value
string   sImpact[1000];
string   DR;

datetime dt[1000]; 
datetime prevTime, nTime, OpenTime;   

bool     fTime;



//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   if (Digits == 4 || Digits == 2) pointvalue = Point;
   else if (Digits == 5 || Digits == 3) pointvalue = 10.0 * Point;
//---- indicators
   SetIndexBuffer(0,buy);
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,233);
   SetIndexEmptyValue(0,0);
   SetIndexBuffer(1,sell);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexEmptyValue(1,0);
   SetIndexArrow(1,234);

//----
//---- Heiken Ashi indicators
   SetIndexStyle(2,DRAW_HISTOGRAM,0,1,Red);
   SetIndexBuffer(2, ExtMapBuffer5);
   SetIndexStyle(3,DRAW_HISTOGRAM,0,1,Chartreuse);
   SetIndexBuffer(3, ExtMapBuffer6);
   SetIndexStyle(4,DRAW_HISTOGRAM,0,2,Red);
   SetIndexBuffer(4, ExtMapBuffer7);
   SetIndexStyle(5,DRAW_HISTOGRAM,0,2,Chartreuse);
   SetIndexBuffer(5, ExtMapBuffer8);
//----
   SetIndexDrawBegin(4,5);
//---- indicator buffers mapping
   SetIndexBuffer(2,ExtMapBuffer5);
   SetIndexBuffer(3,ExtMapBuffer6);
   SetIndexBuffer(4,ExtMapBuffer7);
   SetIndexBuffer(5,ExtMapBuffer8);
   return(0);
  }
  

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   ObjectDelete("S1");
   ObjectDelete("S2");
   ObjectDelete("S3");
   ObjectDelete("SS");   
   ObjectDelete("R1");
   ObjectDelete("R2");
   ObjectDelete("R3");
   ObjectDelete("SR");    
   ObjectDelete("PIVOT");
   ObjectDelete("Support 1");
   ObjectDelete("Support 2");
   ObjectDelete("Support 3");
   ObjectDelete("Pivot level");
   ObjectDelete("Resistance 1");
   ObjectDelete("Resistance 2");
   ObjectDelete("Resistance 3");  
   ObjectDelete("TDR2");
   ObjectDelete("TDR2 Line"); 
   ObjectDelete("BDR2");
   ObjectDelete("BDR2 Line");  
   ObjectDelete(AvBUY150);
   ObjectDelete(AvBUY125); 
   ObjectDelete(AvBUY100); 
   ObjectDelete(AvBUY75); 
   ObjectDelete(AvSELL75); 
   ObjectDelete(AvSELL100);  
   ObjectDelete(AvSELL125);
   ObjectDelete(AvSELL150);     
   Comment(" ");  
   ObjDel();
   return(0);
  }
  
void ReadnPlotCalendar(string fName)
{    
   int i,handle;
   bool rates=false;
   
     
   handle=FileOpen(fName,FILE_CSV|FILE_READ,';');
      if(handle<1)
      {
      Print("File not found ", GetLastError());
      return(false);
      }
   i=0;
   while(!FileIsEnding(handle))
   {
   sDate[i]=FileReadString(handle);          
   sTime[i]=FileReadString(handle);         
   sCurrency[i]=FileReadString(handle);      
   sDescription[i]=FileReadString(handle);   
   sRating[i]=FileReadString(handle);        
   sActual[i]=FileReadString(handle);       
   sForecast[i]=FileReadString(handle);      
   sPrevious[i]=FileReadString(handle);                
   
   int rating = StrToInteger(sRating[i]);
   rates = rating <= MaxRating && rating >= MinRating;
      
   if(!rates) continue;  
   
   if ((sCurrency[i] == "USD") && (!USD)) continue;            
   if ((sCurrency[i] == "EUR") && (!EUR)) continue;            
   if ((sCurrency[i] == "GBP") && (!GBP)) continue;                      
   if ((sCurrency[i] == "JPY") && (!JPY)) continue;
   if ((sCurrency[i] == "AUD") && (!AUD)) continue;
   if ((sCurrency[i] == "CAD") && (!CAD)) continue;                     
   if ((sCurrency[i] == "CHF") && (!CHF)) continue;  
   if ((sCurrency[i] == "NZD") && (!NZD)) continue;   
      
   dt[i] = StrToTime(sDate[i]+" "+sTime[i])+TimeZone*3600;
   if(rating == 3) sImpact[i] = "High";
   if(rating == 2) sImpact[i] = "Medium";
   if(rating == 1) sImpact[i] = "Low";
   
   string info = i+"_"+TimeToStr(dt[i])+" "+sCurrency[i]+" "+" "+sDescription[i]+" "+sImpact[i];
   color c=Yellow ;
   
   if (sCurrency[i] == "USD") c = Blue;  
   if (sCurrency[i] == "EUR") c = Pink; 
   if (sCurrency[i] == "GBP") c = Red;
   if (sCurrency[i] == "JPY") c = Orange;            
   if (sCurrency[i] == "AUD") c = Green;       
   if (sCurrency[i] == "CAD") c = Gray;
   if (sCurrency[i] == "CHF") c = Green;
   if (sCurrency[i] == "NZD") c = Lime;  
      
      if (DisplayText)
      {
      ObjectCreate("TSDT"+i, OBJ_TEXT, 0, dt[i], Close[0]);
      ObjectSet("TSDT"+i, OBJPROP_COLOR, c);          
      ObjectSetText("TSDT"+i,sCurrency[i] + " " + sDescription[i] + " ",8);          
      ObjectSet("TSDT"+i, OBJPROP_ANGLE, 90);          
      }
          
      if (DisplayLine)
      {         
      ObjectCreate("TSDL"+i, OBJ_VLINE, 0, dt[i], Close[0]);
      ObjectSet("TSDL"+i, OBJPROP_COLOR, c);                    
      ObjectSet("TSDL"+i, OBJPROP_STYLE, STYLE_DOT);                    
      ObjectSet("TSDL"+i, OBJPROP_BACK, true);          
      ObjectSetText("TSDL"+i,sDescription[i] + "  ",8);          
      }
      
   i++;
   }
   NewsNum = i;
   
return(0);
}
string ForexTSD_Calendar()
{
   if(!UseStartDate)
   datetime StartWeek = iTime(NULL,PERIOD_W1,0);
   else 
   StartWeek = StartDate;
   
   string StartYear  = TimeYear (StartWeek);
   if (TimeMonth(StartWeek)>9) string StartMonth = TimeMonth(StartWeek);
   else StartMonth = "0" + TimeMonth(StartWeek);
   if (TimeDay(StartWeek)>9) string StartDay   = TimeDay(StartWeek);
   else StartDay = "0" + TimeDay(StartWeek);
   
   string StartTime = StartYear + StartMonth + StartDay;  
      
   string WebAdress = "http://calendar.forex-tsd.com/calendar.php?csv=1&date="+StartTime+"&calendar[]="+CalendarID;
   string result = forextsd_com_webget(WebAdress);
      
   if(result != "") 
   {
   string CalName = "ForexTSD_"+StartYear+"-"+StartMonth+"-"+StartDay+".csv";
   
   Print(CalName," is OK");
   
   int handle=FileOpen(CalName,FILE_CSV|FILE_WRITE,';');
         
      if(handle>0)
      {
      FileWrite(handle, result);
      FileClose(handle);
      }
   }
   else CalName = "";
  
   return(CalName);   
}
//------------------------------------------------------------------  

//------------------------------------------------------------------
int start()
  {
   int shift,limit;
   int counted_bars=IndicatorCounted();
   if (counted_bars<0) return(-1);
   if (counted_bars>0) counted_bars--;
   limit=Bars-Slow-1;
   if(counted_bars>=Slow+1) limit=Bars-counted_bars-1;
 	
 	double emaf11,emaf12,emas21,emas22,t3;
 	
   for(shift = limit; shift >= 0; shift--) {
      t3 = iCustom(NULL,0,"T3 basic",T3Period,T3Price,T3Hot,T3Original,0,shift+SigShift);
      emaf11 = iMA(NULL,0,Fast,0,MODE_EMA,PRICE_CLOSE,shift+SigShift);
      emaf12 = iMA(NULL,0,Fast,0,MODE_EMA,PRICE_CLOSE,shift+1+SigShift);
      emas21 = iMA(NULL,0,Slow,0,MODE_EMA,PRICE_OPEN,shift+SigShift);
      emas22 = iMA(NULL,0,Slow,0,MODE_EMA,PRICE_OPEN,shift+1+SigShift);
   	
      if (emaf11>emas21 && emaf12<=emas22 && emaf11>t3) {
         buy[shift]=Low[shift]-iATR(NULL,0,20,shift)/2.0;
      if ( alertTag!=Time[0])
         {
         if (UseSound==1) 
	         PlaySound(NameFileSound);
         if (CommentOnChart==1) 
             Alert(Symbol(),"  ",Period(),"Mandarine cross Buy");
         }
            alertTag = Time[0];
      }
      else if (emaf11<emas21 && emaf12>=emas22 && emaf11<t3) {
         sell[shift]=High[shift]+iATR(NULL,0,20,shift)/2.0;
         if ( alertTag!=Time[0])
         {
         if (UseSound==1) 
	         PlaySound(NameFileSound);
         if (CommentOnChart==1) 
             Alert(Symbol(),"  ",Period(),"Mandarine cross Sell");
         }
            alertTag = Time[0];
      }
   }
   
   
//+------------------------------------------------------------------+
//| Heiken Ashi indicator iteration function                              
//+------------------------------------------------------------------+
if (ShowHeikenAshi){

   double haOpen, haHigh, haLow, haClose;
   double maOpen, maClose, maLow, maHigh;
   
   if(Bars<=10) return(0);
   ExtCountedBars=IndicatorCounted();
//---- check for possible errors
   if (ExtCountedBars<0) return(-1);
//---- last counted bar will be recounted
   if (ExtCountedBars>0) ExtCountedBars--;
   int pos=Bars-ExtCountedBars-1;
   while(pos>=0)
     {
      maOpen  = iCustom(NULL,NLMA_TF,"NonLagMA_v7.1.1",PRICE_OPEN,NLMA_Length,NLMA_Displace,NLMA_PctFilter,1,0,pos);
      maClose = iCustom(NULL,NLMA_TF,"NonLagMA_v7.1.1",PRICE_CLOSE,NLMA_Length,NLMA_Displace,NLMA_PctFilter,1,0,pos);
      maLow   = iCustom(NULL,NLMA_TF,"NonLagMA_v7.1.1",PRICE_LOW,NLMA_Length,NLMA_Displace,NLMA_PctFilter,1,0,pos);
      maHigh  = iCustom(NULL,NLMA_TF,"NonLagMA_v7.1.1",PRICE_HIGH,NLMA_Length,NLMA_Displace,NLMA_PctFilter,1,0,pos);
      
      haOpen=(ExtMapBuffer7[pos+1]+ExtMapBuffer8[pos+1])/2;
      haClose=(maOpen+maHigh+maLow+maClose)/4;
      haHigh=MathMax(maHigh, MathMax(haOpen, haClose));
      haLow=MathMin(maLow, MathMin(haOpen, haClose));    
      
      if (haOpen<haClose) 
        {
         ExtMapBuffer5[pos]=haLow;
         ExtMapBuffer6[pos]=haHigh;
        } 
      else
        {
         ExtMapBuffer5[pos]=haHigh;
         ExtMapBuffer6[pos]=haLow;
        } 
      ExtMapBuffer7[pos]=haOpen;
      ExtMapBuffer8[pos]=haClose;
 	   pos--;
     }
     } 
     datetime cTime = iTime(NULL,PERIOD_W1,0);
   if (fTime || (TimeCurrent() > cTime && cTime > prevTime))
   {
   string gmt = forextsd_com_webget("http://calendar.forex-tsd.com/gmt.php");
   if(gmt!="") datetime gmtime = StrToTime(gmt);
   else return(0);
   
   int tz = NormalizeDouble((TimeCurrent() - gmtime)/3600.0,0);
   if ( tz < 24) TimeZone = tz;  
   string cName = ForexTSD_Calendar();  
      
   if(cName != "")
   {   
   ReadnPlotCalendar(cName);
   fTime = false;
   prevTime = cTime;
   }
   else 
   {  
   return(0);
   }
   }
   if(AlertMode && TimeToAlert() && TimeCurrent() > nTime) 
   {
   Alert("Upcoming News! Be ready!"); 
   nTime = TimeCurrent() + AlertTimeGap*60;
   }
      //+------------------------------------------------------------------+
//| Money management iteration function                              
//+------------------------------------------------------------------+            
     
   

//+------------------------------------------------------------------+
//| Fibo Pivot indicator iteration function                              
//+------------------------------------------------------------------+
double rates[1][6],yesterday_close,yesterday_high,yesterday_low;
ArrayCopyRates(rates, Symbol(), PERIOD_D1);

if(DayOfWeek() == 1)
{
   if(TimeDayOfWeek(iTime(Symbol(),PERIOD_D1,1)) == 5)
   {
       yesterday_close = rates[1][4];
       yesterday_high = rates[1][3];
       yesterday_low = rates[1][2];
   }
   else
   {
      for(int d = 5;d>=0;d--)
      {
         if(TimeDayOfWeek(iTime(Symbol(),PERIOD_D1,d)) == 5)
         {
             yesterday_close = rates[d][4];
             yesterday_high = rates[d][3];
             yesterday_low = rates[d][2];
         }
         
      }  
      
   }
}
else
{
    yesterday_close = rates[1][4];
    yesterday_high = rates[1][3];
    yesterday_low = rates[1][2];
}


//---- Calculate Pivots
double R = yesterday_high - yesterday_low;//range
double p = (yesterday_high + yesterday_low + yesterday_close)/3;// Standard Pivot
double r3 = p + (R * 1.000);
double r2 = p + (R * 0.618);
double r1 = p + (R * 0.382);
double s1 = p - (R * 0.382);
double s2 = p - (R * 0.618);
double s3 = p - (R * 1.000);

double day_high=0;
double day_low=0;
double nQ=0;
double nD=0;
double D=0;
double Q=0;

day_high = rates[0][3];
day_low = rates[0][2];
D = (day_high - day_low);
Q = (yesterday_high - yesterday_low);

double fb,fs,fe,tp1,tp2,tp3;
double ri,re1,re2,re3,ra1,ra2,ra3;

if (Q > 5) 
{
	nQ = Q;
}
else
{
	nQ = Q*10000;
}

if (D > 5)
{
	nD = D;
}
else
{
	nD = D*10000;
}
 if (StringSubstr(Symbol(),3,3)=="JPY")
{
nQ=nQ/100;
nD=nD/100;     
}
//+------------------------------------------------------------------+
//| Daily Range iteration function                              
//+------------------------------------------------------------------+ 
   int R1=0,R5=0,R10=0,R20=0,RAvg=0;
   int RoomUp=0,RoomDown=0,StopLoss_Long=0,StopLoss_Short=0;
   double   SL_Long=0,SL_Short=0;
   double   low0=0,high0=0,low1=0,high1=0;
   string   Text="";
   int i=0;

   R1 =  (iHigh(NULL,PERIOD_D1,1)-iLow(NULL,PERIOD_D1,1))/pointvalue;
   for(i=1;i<=5;i++)
   R5 = R5  +  (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/pointvalue;
   for(i=1;i<=10;i++)
   R10 = R10 +  (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/pointvalue;
   for(i=1;i<=20;i++)
   R20 = R20 +  (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/pointvalue;

   R5 = R5/ShortRange;
   R10 = R10/InterRange;
   R20 = R20/LongRange;
   RAvg  =  (R1+R5+R10+R20)/4;    

   low0  =  iLow(NULL,PERIOD_D1,0);
   high0 =  iHigh(NULL,PERIOD_D1,0);
   low1  =  iLow(NULL,PERIOD_D1,1);
   high1 =  iHigh(NULL,PERIOD_D1,1);
   RoomUp   =  RAvg - (Bid - low0)/pointvalue;
   RoomDown =  RAvg - (high0 - Bid)/pointvalue;
   StopLoss_Long  =  RoomUp/Risk_to_Reward_ratio;
   SL_Long        =  Bid - StopLoss_Long*pointvalue;
   StopLoss_Short =  RoomDown/Risk_to_Reward_ratio;
   SL_Short       =  Bid + StopLoss_Short*pointvalue; 
   double HIDaily = iMA(Symbol(),PERIOD_D1,1,0,MODE_HIGH,PRICE_HIGH,0);
   double LOWDaily = iMA(Symbol(),PERIOD_D1,1,0,MODE_LOW,PRICE_LOW,0); 
   double YEST_HIDaily = iMA(Symbol(),PERIOD_D1,1,0,MODE_HIGH,PRICE_HIGH,1);
   double YEST_LOWDaily = iMA(Symbol(),PERIOD_D1,1,0,MODE_LOW,PRICE_LOW,1); 
   double Daily_AverageGRAPHICS = (YEST_HIDaily - YEST_LOWDaily)/pointvalue;
   double trailingStop = Range.trailingStop*RAvg;
   double takeProfitlong = RoomUp/Risk_to_Reward_ratio;
   double Longtakeprofit = Bid + takeProfitlong*pointvalue;
   double takeProfitshort = RoomDown/Risk_to_Reward_ratio;
   double Shorttakeprofit = Bid - takeProfitshort*pointvalue;    
   RefreshRates();
   double step   = MarketInfo(Symbol(),MODE_LOTSTEP);
   double minLot = MarketInfo(Symbol(),MODE_MINLOT);
   double maxLot = MarketInfo(Symbol(),MODE_MAXLOT);
   double lots   = BaseLot;
   if (UseAutomaticMM)
   {
      if (Risk>0)
      {
         lots = AccountFreeMargin()*(Risk/100.0)/(R1*Range.stopLoss*MarketInfo(Symbol(),MODE_TICKVALUE)/pointvalue);
      }


   string sComment   = "";
   string sp         = "---------------------------------------------------\n";
   string NL         = "\n";
   
   for (i=0; i<=NewsNum-1; i++)
   { 
      if(TimeCurrent()> dt[i-1] && TimeCurrent() <= dt[i])
      {
      OpenTime = dt[i];
      string upcomNews = sCurrency[i]+" "+sDescription[i]+" Impact=" + sImpact[i]; 
      string upcomTime = TimeToStr(dt[i]);  
         
         if (i-1 >= 0)
         {
         string prevNews = sCurrency[i-1]+" "+sDescription[i-1]+" Impact=" + sImpact[i]; 
         string prevTime = TimeToStr(dt[i-1]);
         }
      }
      
      if(OpenTime > 0 && OpenTime < dt[i])
      {
      string nextNews = sCurrency[i]+" "+sDescription[i]+" Impact=" + sImpact[i];
      string nextTime = TimeToStr(dt[i]);
      break;
      }
      }
   sComment = sp;
   sComment = sComment+"Mandarine Trading System"+NL; 
   sComment = sComment+"ForexTSD Calendar:"+NL;
    
   if(TimeZone >= 0)
   
   sComment = sComment+"Broker\'s Time Zone : GMT + " + TimeZone + NL;
   else
   sComment = sComment+"Broker\'s Time Zone : GMT - " + MathAbs(TimeZone) + NL;
   
   if(MarketInfo(Symbol(),MODE_SWAPLONG)>0) string swap="longs,";
   else swap="shorts.";
   if(MarketInfo(Symbol(),MODE_SWAPLONG)<0 && MarketInfo(Symbol(),MODE_SWAPSHORT)<0) swap="your broker. ";
   int Spread = NormalizeDouble((Ask-Bid)/pointvalue,0);
   int Swaplong = NormalizeDouble(MarketInfo(Symbol(),18),2);
   int Swapshort = NormalizeDouble(MarketInfo(Symbol(),19),2); 
   if( StringFind( Symbol(), "JPY", 0) != -1 )
   { nDigits  = 2;}
   else { nDigits  = 4; }  
   
   
   sComment = sComment+"NEWS :" + NL;
   sComment = sComment+"Previous = " + prevTime  +" "+prevNews  + NL;
   sComment = sComment+"Upcoming = " + upcomTime +" "+upcomNews + NL;
   sComment = sComment+"Next = " + nextTime +" "+nextNews + NL;
   sComment = sComment + sp + NL; 
   sComment = sComment+"Last Tick :" + TimeToStr(CurTime(),TIME_DATE|TIME_SECONDS) + NL; 
   sComment = sComment+"Swap favors " + swap + NL; 
   sComment = sComment+"Swap Long = " + DoubleToStr(Swaplong,nDigits) + NL; 
   sComment = sComment+"Swap Short = " + DoubleToStr(Swapshort,nDigits) + NL; 
   sComment = sComment+"Current Spread = " + DoubleToStr(Spread,nDigits) + NL; 
   sComment = sComment + sp + NL; 
   sComment = sComment+"Average Daily Range = " + RAvg + NL; 
   sComment = sComment+"Prev 01 Day Range = " + R1 + NL;
   sComment = sComment+"Todays Range = " + R5 + NL;
   sComment = sComment+"Room Up = " + RoomUp + NL;
   sComment = sComment+"Room Down = " + RoomDown + NL;
   sComment = sComment + sp + NL;
   sComment = sComment+"Recommended Lotsize = " + DoubleToStr(BaseLot,nDigits) +   "Lots"  + NL;
   sComment = sComment+"Risk to Reward_ratio = " + DoubleToStr(Risk_to_Reward_ratio,nDigits) + NL;
   sComment = sComment+"Maximum StopLosses :"  + NL;
   sComment = sComment+"Long:  " + StopLoss_Long  + " Pips at " + DoubleToStr(SL_Long,nDigits)  + NL;
   sComment = sComment+"Short: " + StopLoss_Short + " Pips at " + DoubleToStr(SL_Short,nDigits) + NL;
   sComment = sComment+"Trailing Stop = " + DoubleToStr(trailingStop,nDigits) +  NL; 
   sComment = sComment + sp + NL; 

  
   Comment(sComment);        
   

   if (ShowLines){
   drawLine(r3,"R3", Resistance_3,1);
   drawLabel("Resistance 3",r3,Resistance_3);
   drawLine(r2,"R2", Resistance_2,2);
   drawLabel("Resistance 2",r2,Resistance_2);
   drawLine(r1,"R1", Resistance_1,0);
   drawLabel("Resistance 1",r1,Resistance_1);

   drawLine(p,"PIVOT",Pivot,1);
   drawLabel("Pivot level",p,Pivot);

   drawLine(s1,"S1",Support_1,0);
   drawLabel("Support 1",s1,Support_1);
   drawLine(s2,"S2",Support_2,2);
   drawLabel("Support 2",s2,Support_2);
   drawLine(s3,"S3",Support_3,1);
   drawLabel("Support 3",s3,Support_3);
   } 
   if (Show_DailyAverageGRAPHICS){
   double AvDN150 = p-YEST_LOWDaily;
   double AvUP150 = p+YEST_HIDaily;
   
   }  
   if (Show_DailyAverageGRAPHICS==true)
   { 
   CreateAvGraphics(AvBUY150,AvUP150,p, DAILY_Av_UP_Color_150 ); 
   CreateAvGraphics(AvSELL150,AvDN150,p,DAILY_Av_DN_Color_150); 
   }      
}
}
void CreateAvGraphics(string DailyAv, double start, double end, color clr)
{
   ObjectCreate(DailyAv, OBJ_RECTANGLE, 0, iTime(NULL,1440,1), start, Time[0], end);
   ObjectSet(DailyAv, OBJPROP_COLOR, clr);
   ObjectSet(DailyAv,OBJPROP_BACK,Daily_AverageGRAPHICS);
   ObjectSet(DailyAv,OBJPROP_WIDTH,0);
   ObjectSet(DailyAv,OBJPROP_STYLE,0);
}

void drawLabel(string name,double lvl,color Color)
{
    if(ObjectFind(name) != 0)
    {
        ObjectCreate(name, OBJ_TEXT, 0, Time[10], lvl);
        ObjectSetText(name, name, 8, "Arial", EMPTY);
        ObjectSet(name, OBJPROP_COLOR, Color);
    }
    else
    {
        ObjectMove(name, 0, Time[10], lvl);
    }
}
void drawLine(double lvl,string name, color Col,int type)
{
         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_HLINE, 0, Time[0], lvl,Time[0],lvl);
            
            if(type == 1)
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            else if(type == 2)
            ObjectSet(name, OBJPROP_STYLE, STYLE_DASHDOTDOT);
            else
            ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);
            
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,1);
            
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_HLINE, 0, Time[0], lvl,Time[0],lvl);
            
            if(type == 1)
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            else if(type == 2)
            ObjectSet(name, OBJPROP_STYLE, STYLE_DASHDOTDOT);
            else
            ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);
            
            ObjectSet(name, OBJPROP_COLOR, Col);        
            ObjectSet(name,OBJPROP_WIDTH,1);
          
         }
  } 

void ObjDel()
{
   int _GetLastError;
   if(DisplayLine && DisplayText) int obtotal = 0.5*ObjectsTotal(); else obtotal = ObjectsTotal();
   for ( int i = 0; i < obtotal; i ++ )
   {
      if (DisplayLine)
      if ( !ObjectDelete( StringConcatenate( "TSDL", i ) ) )
      {
      _GetLastError = GetLastError();
      }
      
      if (DisplayText)
      if( !ObjectDelete( StringConcatenate( "TSDT", i ) ) )
      {
      _GetLastError = GetLastError();
      }
   }
}

   bool TimeToAlert()
   {
   bool result = false;
   for (int i=0; i<=NewsNum; i++)
   { 
   datetime AlertTime = dt[i] - AlertTimeGap*60;
      if((TimeCurrent()>= AlertTime && TimeCurrent() <= AlertTime + 60))
      {result=true; break;}
   }
   return(result);
}